/* bsdefs.c -- Actual definitions of all the variables.
 *
 * bsdefs.h only has the "extern's" of the things declared in here.
 */

#include "bsdefs.h"


/* Initial stuff for line number table.
 *
 * The line number table is a singly-linked list.  The head is "firstline",
 * and the tail is "lastline".  The proper way to check for the end of the
 * list is to compare it to LASTLINE.  Lastline points to itself in case
 * I forget and code something differently (it also neatly ties up the end
 * of the list).
 */

#define LASTLINE	(struct line *)(&lastline)

struct line lastline = { &lastline,0077777,"",_nulline };
struct line firstline = { &lastline,0,"",_nulline };
struct line *curline = LASTLINE;


/* Initial stuff for data statements.
 *
 * "dlist[]" holds pointers to lines that have data on them.  It is initialized
 * in M_FIXUP.  "dlp" used to allocate entries from dlist[], it points to the
 * first free entry.  "dlindx" points within the current data line to the next
 * data item.
 * "dtype" indicates the data type for the last data item.
 */

struct line *dlist[DLSIZ];
int dlp = 0,dlindx = 0, dtype = 0;

